#!/bin/bash
echo "Set up and run a PDOS calculation after mol2_to_fdf.sh"
echo "Written by Svante Hedstrom"
SYSLABEL=${1%.fdf}
if [ ! -e $SYSLABEL.fdf ]
then
    echo "No fdf-file found with specified label. Usage: PDOSsubmit.sh SystemLabel[.fdf]"
    exit
fi

#Filenames and paths
ROOTDIR=$PWD
PDOSFDF=$SYSLABEL"PDOS.fdf"
PDOSDIR=PDOS 

#Copy necessary files to the PDOS folder

mkdir $PDOSDIR
cp *psf $PDOSDIR
#cp Au*TSHS $PDOSDIR
#if [ -e Volt-0.000 ]
#then
#  cp Volt-0.000/*xml $PDOSDIR
#  cp Volt-0.000/*ion $PDOSDIR
#  cp Volt-0.000/*ion.nc $PDOSDIR
#  cp Volt-0.000/"$SYSLABEL"0.000.DM $PDOSDIR/$SYSLABEL.DM
  #cp Volt-0.000/$SYSLABEL.TSHS $PDOSDIR
  #cp Volt-0.000/$SYSLABEL.TSDE $PDOSDIR
#fi
cd $PDOSDIR

#Make the appropriate edits to the fdf inputfile
sed -e "s/NAME?/"$SYSLABEL"PDOS/" ../$SYSLABEL.fdf > $PDOSFDF
sed -i 's/SolutionMethod                  transiesta/SolutionMethod                  diagon/' $PDOSFDF
sed -i 's/ DM.MixingWeight                 0.02/ DM.MixingWeight                 0.01/' $PDOSFDF
echo "%block ProjectedDensityOfStates" >> $PDOSFDF
echo "    -8.00 0.00 0.010 8001 eV" >> $PDOSFDF
echo "%endblock ProjectedDensityOfStates" >> $PDOSFDF
echo "" >> $PDOSFDF

#Prepare and submit the qsub submission script
sed -e 's/FILENAME/'$SYSLABEL'PDOS/g' ~/TranSiestaJobs/CommonFiles/PDOSqsub.sh > $SYSLABEL"PDOS" 
bsub < $SYSLABEL"PDOS"  #${PDOSFDF%.fdf}
