#!/bin/bash
INPUTFILE=${1%.fdf}
if [ ! -e $INPUTFILE.fdf ]
then
    echo "No valid specified inputfile. Usage: TSsubmit.sh fdf-file [Maxvoltage NumerOfVoltages]"
    exit
fi
VOLTMAX=$2
VOLTNUMBERS=$(echo $3-1 |bc)
if [ -z $VOLTMAX ]
then
    LIST="-0.250 -0.200 -0.150 -0.100 0.000 0.100 0.150 0.200 0.250"
    echo "No voltages supplied, using defaults: $LIST"
else
  unset LIST
  VOLTMIN=$(echo "0-"$VOLTMAX | bc -l)
  VOLTRANGE=$(echo $VOLTMAX"- "$VOLTMIN | bc -l)
  VOLTSTEP=$(echo $VOLTRANGE"/"$VOLTNUMBERS | bc -l)
  for ((i=0; i<=$VOLTNUMBERS; i++))
    do
    CURVOLTLONG=$(echo "scale=6; ("$VOLTMAX"- "$VOLTSTEP"*"$i")" | bc)
    CURVOLT=$(awk 'BEGIN{ printf "%.3f\n", '$CURVOLTLONG'/1 }')
    LIST=$LIST" "$CURVOLT
  done
  echo "Voltages are: "$LIST
fi
for Volt in $LIST; do
  workdir=Volt"$Volt"
  pardir=$(basename $PWD)
  if [ -e $workdir ]
    then
    mv -f $workdir $workdir.old
  fi
  mkdir $workdir
  sed 's/'VOLTAGE'/'$Volt'/g' $INPUTFILE.fdf > ./$workdir/$pardir$Volt.fdf
  cp *.psf ./$workdir
  sed -e "s/FILENAME/"$pardir$Volt"/g" ~/TranSiestaJobs/CommonFiles/TSqsub.sh >./$workdir/$pardir$Volt
  cp *TSHS ./$workdir
  cd $workdir
  sed -i 's/NAME?/'$pardir$Volt'/g' $pardir$Volt.fdf 

  bsub < $pardir$Volt
  cd ..
done


