Program ChangeCoordinates
  Implicit None

  Integer  ::  n
  Double Precision, Dimension(:), Allocatable  ::  x, y, z
  Integer, Dimension(:), Allocatable  ::  atom, type2
  Integer, Dimension(:), Allocatable  ::  nuc
  Character(2), Dimension(:), Allocatable  ::  ele
  Double Precision  ::  temp, tempx, tempy, tempz, small
  Double Precision  ::  tx1, tx2, ty1, ty2, tz1, tz2
  Character(2)  ::  tempele
  Integer  ::  j, k, count1, count2, intl, final
  Character(9)  ::  A1, A2
  Character(1)  ::  yesorno
  Open(unit=10, file='coordsnew.xyz')

  Write(*,*)
  
  Open(unit=20, file='coords.xyz', status='old', action='read')
  Read(20,*)  n
  Read(20,*) 
  Allocate(x(1:n), y(1:n), z(1:n), atom(1:n), ele(1:n), type2(1:n), nuc(1:n))
  Do  j = 1, n
     Read(20,*)  ele(j), x(j), y(j), z(j)
  End Do

1 Write(*,*)  "Please insert the two axis which need to be changed."
  Write(*,*)  'If you do not want to change any axis, please insert "s s".'
  Write(*,*)  'If you want to transfer the coordinates, please insert "c c".'
  Read(*,*)  A1, A2
  Write(*,*)

  If  (A1=='x' .AND. A2=='y')  Then
     Do  j = 1, n
        temp = x(j)
        x(j) = y(j)
        y(j) = temp
     End Do
  Else If  (A1=='x' .AND. A2=='z')  Then
     Do  j = 1, n
        temp = x(j)
        x(j) = z(j)
        z(j) = temp
     End Do
  Else If  (A1=='y' .AND. A2=='z')  Then
     Do  j = 1, n
        temp = y(j)
        y(j) = z(j)
        z(j) = temp
     End Do
  Else If  (A1=='c' .AND. A2=='c')  Then
3    Write(*,*)  "Please enter the atom number where it starts and ends to be transfered:"
     Read(*,*)  intl, final
     Write(*,*)  "Please specify what are the perameters in the following transfer equations:"
     Write(*,*)  "x=tx1*x+tx2"
     Write(*,*)  "y=ty1*y+ty2"
     Write(*,*)  "z=tz1*z+tz2"
     Write(*,*)  "Please enter them in the following format:"
     Write(*,*)  "tx1, tx2"
     Write(*,*)  "ty1, ty2"
     Write(*,*)  "tz1, tz2"
     Read(*,*)  tx1, tx2
     Read(*,*)  ty1, ty2
     Read(*,*)  tz1, tz2
     Do  j = intl, final
        x(j) = tx1*x(j)+tx2
        y(j) = ty1*y(j)+ty2
        z(j) = tz1*z(j)+tz2
     End Do
4    Write(*,*) "Do you want to transfer another part of the molecule? (y/n)"
     Read(*,*)  yesorno
     If  (yesorno == 'y')  Then
        Goto 3
     Else If  (yesorno == 'n')  Then
        Goto 2
     Else
        Write(*,*)  "Please enter y or n."
        Goto 4
     End If
  Else If  (A1=='s' .AND. A2=='s')  Then
     Goto 2
  Else
     Write(*,*)  'Please enter "x", "y", or "z" in alphabetical order.'
     Goto 1
  End If

2 Do  k = 1, n-1
     small = z(k)
     Do  j = k+1, n
        If  (z(j) <= small)  Then
           small = z(j)
           tempz = z(k)
           z(k) = z(j)
           z(j) = tempz
           tempx = x(k)
           x(k) = x(j)
           x(j) = tempx
           tempy = y(k)
           y(k) = y(j)
           y(j) = tempy
           tempele = ele(k)
           ele(k) = ele(j)
           ele(j) = tempele
        End If
     End Do
  End Do
  count1 = 1
  Do
     count2 = 1
     Do  k = count1+1, n
        If  (z(k) == z(count1))  Then
           count2 = count2+1
        Else
           Exit
        End If
     End Do
     If  (count2 > 1)  Then
        Do  k = count1, count1+count2-2
           small = y(k)
           Do  j = k+1, count1+count2-1
              If  (y(j) <= small) Then
                 small = y(j)
                 tempz = z(k)
                 z(k) = z(j)
                 z(j) = tempz
                 tempx = x(k)
                 x(k) = x(j)
                 x(j) = tempx
                 tempy = y(k)
                 y(k) = y(j)
                 y(j) = tempy
                 tempele = ele(k)
                 ele(k) = ele(j)
                 ele(j) = tempele
              End If
           End Do
        End Do
     End If
     count1 = count1 + count2
     If  (count1 >= n)  Exit
  End Do
  count1 = 1
  Do
     count2 = 1
     Do  k = count1+1, n
        If  (z(k) == z(count1) .AND. y(k) == y(count1))  Then
           count2 = count2+1
        Else
           Exit
        End If
     End Do
     If  (count2 > 1)  Then
        Do  k = count1, count1+count2-2
           small = x(k)
           Do  j = k+1, count1+count2-1
              If  (x(j) <= small) Then
                 small = x(j)
                 tempz = z(k)
                 z(k) = z(j)
                 z(j) = tempz
                 tempx = x(k)
                 x(k) = x(j)
                 x(j) = tempx
                 tempy = y(k)
                 y(k) = y(j)
                 y(j) = tempy
                 tempele = ele(k)
                 ele(k) = ele(j)
                 ele(j) = tempele
              End If
           End Do
        End Do
     End If
     count1 = count1 + count2
     If  (count1 >= n)  Exit
  End Do

  Write(10,*)  n
  Write(10,*)
  Do  j = 1, n
     Write(10,'(A4,3F14.8)')  ele(j), x(j), y(j), z(j)
  End Do

  Write(*,*)'Written by W. Ding, Yale Univ. Chem. Dep.'
  
End Program  ChangeCoordinates

