	program fmPDOS
C
C       add-on to extrtact data from PDOS file of SIESTA
C       Andrei Postnikov, Osnabrueck University, Germany
C       apostnik@uos.de
C
C	formats PDOS file into a table for selected
C	atoms and orbitals
C
	implicit none
	integer nt,nmax,ispin,nspin,norbs,it,nene,is,idos,l,lref,
     .          m,mref,z,atind,n,nref,indref,index
	parameter (nmax=10000)
	real*8 ene(nmax),dos(nmax,2),dos1(2)
	character*80 fin,fout,string
	character*5 key
	character*1 s1
        logical redos

        do it=1,nmax
        do is=1,2
          dos(it,is)=0.d0
        enddo 
        enddo 

	write (6,*) ' Input file name (PDOS):'
	read (5,*) fin
	open (11,file=fin,status='old',form='formatted')
	write (6,*) ' Output file name :'
	read (5,*) fout
	open (12,file=fout,status='new',form='formatted')

        write (6,*) ' Extract data for atom index (0 for all): '
        read (5,*) indref
        write (12,301)indref
  301   format('#',/,'#   partial DOS for atom index ',i5,/,'#')
        write (6,*) ' Extract data for n= ... (0 for all n ):'
        read (5,*) nref
        if (nref.ne.0) then
          write (6,*) ' Extract data for l= ... (-1 for all l ):'
          read (5,*) lref
          if (lref.ne.-1) then 
            write (6,*) ' Extract data for m= ... (9 for all m ):'
            read (5,*) mref
          else
            mref=9
          endif 
        else 
          lref=-1
          mref=9
        endif 

        redos = .false.
        nene=0
   11   continue
	read (11,'(a80)',err=201,end=202) string
C       write (6,*) '  string ->',string,'<-- '
	read (string,101) key
C       write (6,*) '  key ->',key,'<--- '
  101  format(1x,a5)	
	  if (key.eq.'pdos>') goto 11
	  if (key.eq.'nspin') then
	    read (string,102) nspin
	    write (6,*)'  NSPIN=',nspin
            goto 11
  102  format(7x,i1)	
	  elseif (key.eq.'norbi') then
	    read (string,103) norbs
	    write (6,*)'  NORBS=',norbs
            goto 11
  103  format(11x,i4)	
          elseif (key.eq.'energ') then   !  list of energies follows:
            nene=0
            goto 11
          elseif (key.eq.'     ') then   !  must be an energy line:
                                         !    read energy values
            nene=nene+1
            read (string,*) ene(nene)
            goto 11
          elseif (key.eq.'/ener') then   !  list of energies closes:
            nt=nene
            write (6,*) nt,'  energy values found:'
C           do it=1,nt
C             write(6,203) it,ene(it)
C           enddo
  203  format(i5, f12.6)
            if (nt.gt.nmax) then
              write(6,*)'  nt=',nt,' > nmax=',nmax
              stop
            endif 
            goto 11

          elseif (key.eq.'orbit') then   !  new orbital follows:
            goto 11
          elseif (key.eq.'index') then   !  orbital index line:
	    read (string,106) index
  106  format(8x,i25)
C           write (6,*)'  index foud = ',index
            goto 11
          elseif (key.eq.'atom_') then   !  atom index line:
	    read (string,104) atind
  104  format(13x,i25)
C           write (6,*)'  atind foud = ',atind
            if (atind.eq.indref.or.indref.eq.0) redos=.true.
            goto 11
          elseif (key.eq.'speci') then   !  atom species line:
            goto 11
          elseif (key.eq.'posit') then   !  atom position line:
            goto 11
          elseif (key.eq.'n="  ') then   !  n-value:
	    read (string,105) n
  105  format(4x,i25)
C           write (6,*)'  n found = ',n
            if (nref.ne.0.and.n.ne.nref) redos=.false.
            goto 11
          elseif (key.eq.'l="  ') then   !  l-value:
	    read (string,105) l
C           write (6,*)'  l found = ',l
            if (lref.ne.-1.and.l.ne.lref) redos=.false.
            goto 11
          elseif (key.eq.'m="  ') then   !  m-value:
	    read (string,105) m
C           write (6,*)'  m found = ',m
            if (mref.ne.9.and.m.ne.mref) redos=.false.
            goto 11
          elseif (key.eq.'z="  ') then   !  z-value:
	    read (string,105) z
C           write (6,*)'  z found = ',z
	    read (11,'(a1)') s1    !   read in an extra line
            goto 11
          elseif (key.eq.'data>') then   !  list of PDOS follows:
            if (redos) write (12,302) n,l,m,z
  302  format ('#   Add data for n,l,m,z=',4i3)
            do it=1,nt
              read (11,*) (dos1(ispin),ispin=1,nspin)
              if (redos) then
                do ispin=1,nspin
                  dos(it,ispin)=dos(it,ispin)+dos1(ispin)
                enddo
              endif
            enddo
            redos=.false.
            goto 11
          elseif (key.eq.'/data') then   !  list of PDOS closes:
            goto 11
          elseif (key.eq.'/orbi') then   !  orbital ends:
            goto 11
          elseif (key.eq.'/pdos') then   !  pdos ends:
            goto 11
          endif
  201   continue
        write(6,*) ' error'
	stop
  202   continue
        write(6,*) ' end of file'
        close (11)

        write (12,303)
  303 format('#',/,'#    Energy',10x,'spin 1',8x,'spin2',/,'#')    
        do it=1,nt
          write (12,304) ene(it),(dos(it,ispin),ispin=1,nspin)
        enddo
  304  format (3f14.8)
        close (12)

	stop
	end

	
	
