#!/bin/bash
echo "Extract PDOS for a specified fragment after PDOS Siesta calculation"
#echo "Written by Svante Hedstrom"
SYSLABEL=${1%.PDOS}
STARTATOM=$2
ENDATOM=$3
if [ ! -e $SYSLABEL.PDOS ]
then
    echo "No PDOS-file found with specified label. Usage: fragPDOS.sh SystemLabel[.PDOS] Startatom Endatom"
    exit
fi
PDOSDIR=$PWD
INPFILE="$SYSLABEL"_"$STARTATOM"_"$ENDATOM".in
OUTFILE="$SYSLABEL"_"$STARTATOM"_"$ENDATOM".pdos
echo "Efermi@"$(grep "ElectronicTemperature" $SYSLABEL.out | tail -1 | awk '{print $2}')"K = "$(grep "0.0000 -" $SYSLABEL.out | tail -1 | awk '{print $7}')
TMPFRAGDIR=tempdir$STARTATOM$ENDATOM
mkdir $TMPFRAGDIR
cp $SYSLABEL.PDOS $TMPFRAGDIR
cd $TMPFRAGDIR
echo $SYSLABEL.PDOS > $INPFILE
echo $OUTFILE >> $INPFILE
echo 1 >> $INPFILE
echo $STARTATOM >> $INPFILE
echo $ENDATOM >> $INPFILE
echo "0 

" >> $INPFILE

mypdos < $INPFILE >/dev/null
mv $INPFILE $PDOSDIR
mv $OUTFILE $PDOSDIR
cd $PDOSDIR
rm -rf $TMPFRAGDIR

