#!/bin/bash

for a in *mol2
  do 
  NAME=${a%.mol2} #Basename of mol2-file. Will be used throughout
  babel $NAME.mol2 $NAME.xyz #Convert to xyz
  cp ~/TranSiestaJobs/CommonFiles/AuLeads.TSHS . #Change to the folder where your default Leads TSHS file is
  cp $NAME.xyz coords.xyz
  proper_shift 
  mv coords_shifted.xyz coords.xyz
  change_xyz
  rm -f coords.xyz
  xyz_to_fdf
  mv coordsnew.fdf $NAME.fdf
  NUMATOMS=$(grep NumberOfAtoms $NAME.fdf | awk '{print $2}')
  sed -e 's/HOW_MANY_ATOMS/'$NUMATOMS'/g' ~/TranSiestaJobs/CommonFiles/fdftemplate.fdf > temp.fdf
  sed -i 's/AND_SPECIES/'$(grep NumberOfSpecies $NAME.fdf | awk '{print $2}')'/g' temp.fdf
  sed -i 's/WHATS_THE_VECTOR/'$(grep "     0.000    0.000" $NAME.fdf | awk '{print $3}')'/g' temp.fdf
  j=1
  while read -r line ; do
    BASISSTRING=$(grep basisset $NAME.fdf | head -$j | tail -1 | awk '{print $1}')
    sed -i '/endblock  PAO.BasisSizes/i '$BASISSTRING'  DZ' temp.fdf
    cp ~/TranSiestaJobs/CommonFiles/$BASISSTRING.psf .
    SPECIESTRING1=$(echo $line | awk '{print $1}')
    SPECIESTRING2=$(echo $line | awk '{print $2}')
    SPECIESTRING3=$(echo $line | awk '{print $3}')
    sed -i '/endblock ChemicalSpeciesLabel/i '$SPECIESTRING1' '$SPECIESTRING2' '$SPECIESTRING3' ' temp.fdf
    j=$(echo $j+1 | bc)
  done < <(grep "Species index" $NAME.fdf)
  COORDSLINES=$(echo $NUMATOMS+2 | bc)
  tail -$COORDSLINES $NAME.fdf >> temp.fdf
  mv temp.fdf $NAME.fdf
done

  