!*************************************************************
! A program to extract the coordinates form the xyz file  
! to build a FEFF input
!************************************************************

program xyztofdf
  implicit none

  integer, parameter :: dp = kind(1.0d0)

  character(5) :: string
  integer :: i,atoms, count, index, Natoms,Nsp,spz(1000),N,j,k,posible_atom
  integer, allocatable :: atom_number(:),species(:), sp(:)
  real(dp) :: x,y,z,lmax,lmax_1,lmin,period
  real(dp), allocatable :: r(:,:)
  integer, allocatable :: atomhold(:), holdsec(:,:)
  character(2), allocatable :: atom_type(:),sp_name(:)
  character(1) :: yorn
  character(100) :: fileGeomConstraint
  integer :: type_of_input, numatomhold, numholdsec


!-------------------------------------------------!     
!      Periodic table					          !
!-------------------------------------------------!   
   integer, parameter :: NZ = 103 

   character(len=2), parameter :: ELENAME(NZ) = &
             (/'H ','He','Li','Be','B ','C ','N ','O ','F ','Ne', &
               'Na','Mg','Al','Si','P ','S ','Cl','Ar','K ','Ca', &
               'Sc','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu','Zn', &
               'Ga','Ge','As','Se','Br','Kr','Rb','Sr','Y ','Zr', &
               'Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd','In','Sn', &
               'Sb','Te','I ','Xe','Cs','Ba','La','Ce','Pr','Nd', &
               'Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb', &
               'Lu','Hf','Ta','W ','Re','Os','Ir','Pt','Au','Hg', &
               'Tl','Pb','Bi','Po','At','Rn','Fr','Ra','Ac','Th', &
               'Pa','U ','Np','Pu','Am','Cm','Bk','Cf','Es','Fm', &
               'Md','No','Lr'/)

        Write(*,*)
        write(*,*)'#########################################################'
        write(*,*)'#       Default input for running TS calulations        #'
        write(*,*)'#  Written by C.F.A. Negre, Yale University, Chem. Dep. #'
        write(*,*)'#  Modified by Wendu Ding, Yale University, Chem. Dep.  #'
        write(*,*)'#########################################################'
        write(*,*)

	open(unit=1,file='coordsnew.xyz',status='old',action='read')
	open(unit=2,file='coordsnew.fdf')
	
!Counts the number of atoms
	read(1,*)Natoms
  read(1,*)

	allocate(r(Natoms,3))
	allocate(atom_type(Natoms))
	allocate(atom_number(Natoms))
  allocate(species(Natoms))
  allocate(sp(Natoms))
  allocate(sp_name(Natoms))


  do i=1,Natoms
      read(1,*)atom_type(i), r(i,1), r(i,2), r(i,3)
!       write(*,*)atom_type(i), r(i,1), r(i,2), r(i,3)
  enddo

  do i=1,Natoms
    do j=1,NZ
      if(atom_type(i).EQ.ELENAME(j)) atom_number(i)=j
    enddo
  enddo

  species(1)=atom_number(1)
  sp_name(1)=atom_type(1)
  nsp=1
  count=0

    do i=1,Natoms
      do j=1,nsp
        if(atom_number(i).NE.species(j).and.species(j).NE.0)then
				posible_atom=atom_number(i)
				count=count+1
				endif
      enddo
      if(count.EQ.nsp)then
        nsp=nsp+1
				species(nsp)=posible_atom
				sp_name(nsp)=ELENAME(posible_atom)
      endif
      count = 0
    enddo
 
! Here we asing an specie number 1,2,3 ...
 
  do i=1,Natoms 
    do j=1,nsp
        if(atom_number(i).EQ.species(j)) sp(i)=j
      enddo	
!       write(*,*)sp(i)
    enddo

! 		do i=1,Nsp
! 			write(*,*)species(i),sp_name(i)
!  	  enddo


        write(*,*)'Select the type of input:'
        write(*,*)'(1) Leads'
        write(*,*)'(2) Isolated molecule energy'
        write(*,*)'(3) Extended molecule optimization'
        write(*,*)'(4) Extended molecule transport'
        write(*,*)'(5) PBC optimization'
!1       read(*,*)type_of_input
 1       type_of_input=4
        Write(*,*)  type_of_input
        if(type_of_input < 1 .OR. type_of_input > 5)then
          write(*,*) 'Please select available options.'
          goto 1
        endif
         write(*,*)''
	 write(*,*)'Calculating periodicity ...'
  
	lmax=-1000.0
	lmin=1000.0
	lmax_1=-1000.0

		do i=1,Natoms
			if(r(i,3).GT.lmax)lmax=r(i,3)
			if(r(i,3).LT.lmin)lmin=r(i,3)
 	  enddo

		do i=1,Natoms
			if(r(i,3).GT.lmax_1.and.r(i,3).LT.lmax)lmax_1=r(i,3)
 	  enddo

		period=lmax-lmin+lmax-lmax_1
!     write(*,*)lmax,lmin,lmax_1

!Default header for TS run....
	write(2,*)'#########################################################'
	write(2,*)'#       Default input for running TS calulations        #'
	write(2,*)'#  Written by C.F.A. Negre, Yale University, Chem. Dep. #'
        write(2,*)'#  Modified by Wendu Ding, Yale University, Chem. Dep.  #'
	write(2,*)'#########################################################'  
	write(2,*)''
	if(type_of_input==1)then
		write(2,*)'SystemName       Transport (lead)  # This has to be always Transport for TRANSIESTA'
		write(2,*)'SystemLabel      Lead    # Short name for naming files'
	elseif(type_of_input==2)then
                write(2,*)'SystemName       Energy (isolated molecule)'
                write(2,*)'SystemLabel      MyMol'
        elseif(type_of_input==3)then
                write(2,*)'SystemName       Optimization (extended molecule)'
                write(2,*)'SystemLabel      MyMol'
        elseif(type_of_input==4)then
                write(2,*)'SystemName       Transport (extended molecule)  # Descriptive name of the system'
                write(2,*)'SystemLabel      MyMol    # Short name for naming files'
        elseif(type_of_input==5)then
                write(2,*)'SystemName       Optimization (PBC)'
                write(2,*)'SystemLabel      MyMol'
        endif
  write(2,*)' '
  write(2,*)'#-- Calcualtion Method'
  write(2,*)' '
        if(type_of_input==4)then
        write(2,*)'SolutionMethod                  transiesta'
        else
        write(2,*)'SolutionMethod                  diagon'
        endif
  write(2,*)
  Write(2,*)'#-- LDOS'
  Write(2,*)
  Write(2,*)'# SaveRho T'
  Write(2,*)'# SaveElectrostaticPotential T'
  Write(2,*)
  if(type_of_input==2)then
    Write(2,*)'  %block ProjectedDensityOfStates'
    Write(2,*)'   -10.00 5.00 0.010 5000 eV'
    Write(2,*)'  %endblock ProjectedDensityOfStates'
  else
    Write(2,*)'# %block ProjectedDensityOfStates'
    Write(2,*)'#  -10.00 5.00 0.010 5000 eV'
    Write(2,*)'# %endblock ProjectedDensityOfStates'
  endif
  write(2,*)' '
  Write(2,*)'# %block LocalDensityOfStates'
  Write(2,*)'#  -4.200 -4.180 eV'
  Write(2,*)'# %endblock LocalDensityOfStates'
  Write(2,*)
  write(2,*)'#-- LATTICE'
  write(2,*)' '
  write(2,*)'LatticeConstant         1.0000 Ang'
  write(2,*)'%block LatticeVectors'
  write(2,*)'   30.000    0.000    0.000'
  write(2,*)'    0.000   30.000    0.000'
  if(type_of_input==1) then ! .OR. type_of_input==4)then
    period=period
  else if (type_of_input==3)  then
    period=period+15.0
  else if (type_of_input==4)  then
    period=period+0.0
  else if (type_of_input==5)  then
    period=period+15.0
  else
    period=period+30.0
  endif
  write(2,'(a19,3f10.5)')'     0.000    0.000',period
! write(2,*)'    0.000    0.000   30.000'
  write(2,*)'%endblock LatticeVectors'
	write(2,*)''
	write(2,*)'#-- BASIS SET'
  write(2,*)' '
	write(2,*)'PAO.BasisType split '
	write(2,*)'PAO.SplitNorm 0.15'
	write(2,*)'# PAO.BasisSize DZP     #This flag sets the same basis set for all atoms'
	write(2,*)'%block    PAO.BasisSizes'
	do i=1,nsp
		write(2,*)'    ',sp_name(i),'  basisset'
	enddo
	write(2,*)'%endblock  PAO.BasisSizes'
	write(2,*)'PAO.EnergyShift   PAOEshift'
	write(2,*)''
	write(2,*)'#-- K-POINTS'
  write(2,*)' '
        write(2,*)'%block kgrid_Monkhorst_Pack'
  write(2,*)'  kpx   0   0    kpxdisp'
  write(2,*)'    0 kpy   0    kpydisp'
  write(2,*)'    0   0 kpz    kpzdisp'
	write(2,*)'%endblock kgrid_Monkhorst_Pack'
	write(2,*)'BandLinesScale          ReciprocalLatticeVectors'
	write(2,*)''
	write(2,*)'#-- GENERAL VARIABLES'
  write(2,*)' '
	write(2,*)'#- Exchange-correlation functionals'
	write(2,*)'XC.functional         GGA    # LDA or GGA'                                  
	write(2,*)'XC.authors            PBE   # CA = PZ, PW92, PBE'          
	write(2,*)'MeshCutoff  cutoff Ry'
	write(2,*)''
	write(2,*)'#-- SPIN OPTIONS'
  write(2,*)' '
	write(2,*)'SpinPolarized                   F               # T, F'
	write(2,*)'FixSpin                         F '
	write(2,*)'TotalSpin                       EleSpin'
	write(2,*)'NonCollinearSpin                F               # T, F'
	write(2,*)''
        write(2,*)'#%block DM.InitSpin'
        write(2,*)'#  6          +1.                 # Atom index, spin, theta, phi (deg)'
        write(2,*)'#  5          -1.                 # Atom index, spin, theta, phi (deg)'
        write(2,*)'#%endblock DM.InitSpin'
        write(2,*)''
	write(2,*)'#-- SCF OPTIONS'
  write(2,*)' '
        write(2,*)'OccupationFunction             FD'
        write(2,*)'#OccupationMPOrder              10'
        if (type_of_input==2) then
	  write(2,*)'ElectronicTemperature           10 K'         
	else
          write(2,*)'ElectronicTemperature           EleTemperature K'
        endif
        write(2,*)'MaxSCFIterations                30000'	
	write(2,*)'DM.MixingWeight                 0.02'
	write(2,*)'DM.NumberPulay                  20          # Pulay convergency accelerator'
	write(2,*)'#DM.MixSCF1                      T'	
	write(2,*)'#DM.MixH                         T'	
	write(2,*)'#DM.PulayOnFile                  F       # Store in memory (F) or in files (T)'
	if(type_of_input==3.OR.type_of_input==5)then
          write(2,*)'DM.Tolerance                    1.0D-4'
        else
          write(2,*)'DM.Tolerance                    1.0D-5'
        endif
	write(2,*)'DM.UseSaveDM                    T'
	write(2,*)''
        if(type_of_input==3.OR.type_of_input==5)then
          write(2,*)'#-- MD OPTIMIZATION OPTIONS'
          write(2,*)
          write(2,*)'MD.VariableCell      F'
          write(2,*)'MD.TypeOfRun         CG'
          write(2,*)'MD.NumCGsteps        500'
          write(2,*)'MD.MaxCGDispl         0.1  Ang'
          write(2,*)'MD.MaxForceTol        0.04 eV/Ang'
          write(2,*)'MD.MaxStressTol       0.0010 eV/Ang**3'
          write(2,*)
4         write(*,*)  "Do you want to have any constraints on certain atoms? y/n"
!         read(*,*) yorn
          yorn = 'y'
          write(*,*)  yorn
          if(yorn=='y')then
            
5           write(*,*) "Is there a file containing constrain atom positions? y/n"
!           read(*,*) yorn
            yorn = 'y'
            write(*,*)  yorn
            if (yorn == 'n') then
              write(2,*)'%block GeometryConstraints'
          !   write(2,*)' position 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 &
          !             21 22 23 24 25 26 27 28 29 30 31 32 33 34 '
          !   write(2,*)' position 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 &
          !             83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 '
          !   write(2,*)' position 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 &
          !             90 91 92 93 94 95 96 97 98 99 100 101 102 103'
          !1  do  j = 1, 99
          !1    write(2,*)  "position", j
          !1  enddo
          !1  do  j = 133, 231
          !1    write(2,*)  "position", j
          !1  enddo
              write(2,*)  "position from 1 to 99"
              write(2,*)  "position from 133 to 231"
              write(2,*)'%endblock GeometryConstraints'
            elseif (yorn=='y')then
              write(*,*) "Please insert file name."
!             read(*,*)  fileGeomConstraint
              fileGeomConstraint = 'GeomConstraint.txt'
              write(*,*)  "Constraint information from file:",fileGeomConstraint
              open(unit=10,file=fileGeomConstraint,status='old',action='read')
              read(10,*)  numholdsec
              allocate(holdsec(1:numholdsec,1:numholdsec))
              do j=1,numholdsec
                read(10,*)  holdsec(j,1), holdsec(j,2)
                do k=1,2
                  if (holdsec(j,k)==0) then
                    holdsec(j,k)=Natoms
                  else if (holdsec(j,k)<0) then
                    holdsec(j,k)=holdsec(j,k)+1+Natoms
                  else
                    holdsec(j,k)=holdsec(j,k)
                  end if
                end do
              enddo
          !2  read(10,*)  numatomhold
          !2  allocate(atomhold(1:numatomhold))
          !2  do j=1, numatomhold
          !2    read(10,*)  atomhold(j)
          !2  enddo
              write(2,*)'%block GeometryConstraints'
              do j=1, numholdsec
                if (holdsec(j,1) == holdsec(j,2)) then
                  write(2,*)  ' position ', holdsec(j,1)
                  write(*,*)  ' position ', holdsec(j,1)
                else
                  write(2,*)  ' position from ',holdsec(j,1),' to ',holdsec(j,2)
                  write(*,*)  ' position from ',holdsec(j,1),' to ',holdsec(j,2)
                endif
              enddo
          !2  do j=1, numatomhold
          !2    write(2,*) ' position ', atomhold(j)
          !2  enddo
              write(2,*)'%endblock GeometryConstraints'
            else
              write(*,*) 'Please enter y or n.'
              goto 5
            endif
          elseif(yorn/='n')then
            write(*,*) 'Please enter y or n.'
            goto 4
          endif
          write(2,*)
          write(2,*)'WriteCoorXmol   .true.'
          write(2,*)
        endif

        if(type_of_input==4)then
	write(2,*)'#-- TRANSPORT VARIABLES'
  write(2,*)' '
	write(2,*)'#- ELECTRODES'
        write(2,*)'#  TS.CalcGF              false'
	write(2,*)'TS.HSFileLeft   LeadsFile'
	write(2,*)'TS.NumUsedAtomsLeft    LeadsAtomNum'
	write(2,*)'TS.HSFileRight  LeadsFile'
	write(2,*)'TS.NumUsedAtomsRight   LeadsAtomNum'
	write(2,*)''
	write(2,*)'#- TRANSPORT BLOCK'
	write(2,*)'TS.TBT.NPoints        8001'
	write(2,*)'TS.TBT.Emin           -4.0 eV'
	write(2,*)'TS.TBT.Emax             4.0 eV'
	write(2,*)'TS.TBT.OutputRegionData False'
	write(2,*)'TS.BiasContour.NumPoints 100'
	write(2,*)'TS.ComplexContour.Emin  -20.0 Ry'
	write(2,*)'TS.ComplexContour.NumCircle 100'
	write(2,*)'TS.ComplexContour.NumLine  20'
	write(2,*)'TS.ComplexContour.NumPoles 10'
	write(2,*)'TS.BiasContour.Eta 10D-4  Ry'
	write(2,*)'TS.Voltage VOLTAGE  eV'
	endif
	write(2,*)''
	write(2,*)'#-- SYSTEM'
  write(2,*)' '
  write(2,*)'NumberOfAtoms ',Natoms   
  write(2,*)'NumberOfSpecies',nsp
  write(2,*)'NetCharge        systemcharge'
  write(2,*)' '
	write(2,*)'%block ChemicalSpeciesLabel'
	do i=1,nsp
		write(2,*) i, species(i), sp_name(i),  '    # Species index, atomic number, species label'
	enddo
	write(2,*)'%endblock ChemicalSpeciesLabel'
	write(2,*)' '
	write(2,*)'AtomicCoordinatesFormat  Ang'
  write(2,*)'%block AtomicCoordinatesAndAtomicSpecies'
	do i=1,Natoms	
		write(2,'(3F14.8,I4,A4,I4)') r(i,1), r(i,2), r(i,3), sp(i), atom_type(i), i
	enddo 
	write(2,*)'%endblock AtomicCoordinatesAndAtomicSpecies'
  write(2,*)''

  write(*,*)  "Standard input for TS calculation ready."
  write(*,*)

end program xyztofdf


  
